<?php
/**
 * Created by PhpStorm.
 * User: Yulius Ardian Febrianto <yuliusardin@gmail.com>
 * Date: 21/01/2020
 * Time: 20:56
 */

namespace AppBundle\Security\UserProvider;

use AppBundle\Api\v1\Loyalty\{Member, Access};

use AppBundle\Api\v1\Rewards\Account;
use AppBundle\Api\v1\Membership\Account as MembershipAccount;

use AppBundle\Exception\Auth\BadCredentialsException;
use AppBundle\Exception\Auth\UserInactiveException;
use AppBundle\Model\DataObject\Customer;
use Carbon\Carbon;
use CustomerManagementFrameworkBundle\CustomerProvider\CustomerProviderInterface;
use CustomerManagementFrameworkBundle\Security\UserProvider\CustomerObjectUserProvider as BaseCustomerObjectUserProvider;
use Pimcore\Model\WebsiteSetting;
use Pimcore\Translation\Translator;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Session\SessionInterface;
use Symfony\Component\Routing\Generator\UrlGeneratorInterface;
use Symfony\Component\Security\Core\User\UserInterface;

class CustomerObjectUserProvider extends BaseCustomerObjectUserProvider
{
    /** @var Member $member */
    private $member;

    /** @var SessionInterface $session */
    private $session;

    /** @var Translator $translator */
    private $translator;

    /** @var Access $loyaltyAccess */
    private $loyaltyAccess;

    /** @var Account $account */
    private $account;

    /** @var MembershipAccount $membershipAccount */
    private $membershipAccount;

    /** @var UrlGeneratorInterface $router */
    private $router;

    public function __construct(
        CustomerProviderInterface $customerProvider,
        string $usernameField = 'email',
        SessionInterface $session,
        ContainerInterface $container
    )
    {
        parent::__construct($customerProvider, $usernameField);

        $this->session = $session;

        if (env('RRR_LIVE')) {
            $this->member = new Member();
            $this->loyaltyAccess = new Access();
        }

        if (!env('RRR_LIVE')) {
            $this->account = new Account();
            $this->membershipAccount = new MembershipAccount();
        }

        $this->translator = $container->get('translator');
        $this->router = $container->get('router');

    }

    public function loadUserByUsername($username)
    {
        $request = Request::createFromGlobals();

        $usernameLoginSso = $request->get('username') ?? $request->get('Email');
        $passwordLoginSso = $request->get('password') ?? $request->get('Password');

        $hasFromDotNet = $this->session->has('fromDotNET');
        $hasFromApi = $this->session->has('fromApi');

        if ($usernameLoginSso && $passwordLoginSso) {
            $ssoLogin = $this->ssoLogin($usernameLoginSso, $passwordLoginSso, false);
            if (!$ssoLogin) {
                throw new BadCredentialsException($this->translator->trans('BAD_CREDENTIALS'));
            }
        }

        if ($hasFromDotNet) {
            $fromCookie = $this->fromCookieNet($request);

            if (!$fromCookie) {
                throw new BadCredentialsException($this->translator->trans('BAD_CREDENTIALS'));
            }
        }

        if ($hasFromApi) {
            $fromApi = $this->fromApi($request);
            if (!$fromApi) {
                throw new BadCredentialsException($this->translator->trans('BAD_CREDENTIALS'));
            }
        }

        /** @var Customer $obj */
        $obj = parent::loadUserByUsername($username);

        return $obj;
    }

    public function refreshUser(UserInterface $user)
    {
        return parent::refreshUser($user); // TODO: Change the autogenerated stub
    }

    public function supportsClass($class)
    {
        return parent::supportsClass($class);
    }

    public function ssoLogin($username, $password, $remember = false)
    {
        if (env('RRR_LIVE')) {
            $login = $this->loyaltyAccess->login($username, $password, $remember);
        }

        if (!env('RRR_LIVE')) {
            $login = $this->membershipAccount->loginRevamp($username, $password, $remember);
        }

        if ($login['StatusCode'] === '00') {
            $accessToken = $login['Value']['AccessToken'];
            $this->session->set('AccessToken', $accessToken);

            $this->setActionTokenCookie($accessToken);

            $expiredDateCarbon = Carbon::now()->addMinutes(env('EXPIRED_ACCESS_TOKEN', 30))->timestamp;
            $this->session->set('ExpiredDate', $expiredDateCarbon);

            if (env('RRR_LIVE')) {
                $profile = $this->member->profile($accessToken);
            }

            if (!env('RRR_LIVE')) {
                $profile = $this->account->profile($accessToken);
            }

            if ($profile['StatusCode'] === '00') {
                $customer = new Customer();
                $customer->setValues($profile['Value']);

                $this->session->set('UserProfileRaw', $profile['Value']);
                $this->session->set('UserProfile', $customer);
                return $profile;
            }
        }

        // if status 71 and value IsActive === false. redirect to activation page;
        if ($login['StatusCode'] === '71' && !$login['Value']['IsActive']) {
            $customMessage = WebsiteSetting::getByName('ACTIVATION_LINK_TO_DOT_NET') ?
                WebsiteSetting::getByName('ACTIVATION_LINK_TO_DOT_NET')->getData() : null;

            $activation = $this->router
                ->generate('account-login', [], UrlGeneratorInterface::ABSOLUTE_URL);


            $dotNetDomain = env('WILDCARD_DOMAIN_FOR_DOT_NET', null);

            $expiredCookie = Carbon::now()->addMinutes(15)->timestamp;

            setrawcookie(
                'urlreferer',
                $activation,
                $expiredCookie,
                '/',
                $dotNetDomain
            );

            throw new UserInactiveException($customMessage ?? $login['Message'] ?? $login['StatusMessage'] ?? 'User Inactive');
        }

        return null;
    }

    private function fromCookieNet(Request $request)
    {
        $cookieName = getenv('COOKIE_NAME_DOT_NET_AUTOLOGIN', null);

        $cookies = $request->cookies;
        $accessToken = $cookies->get($cookieName);

        if (env('RRR_LIVE')) {
            $profile = $this->member->profile($accessToken);
        }

        if (!env('RRR_LIVE')) {
            $profile = $this->account->profile($accessToken);
        }

        if ($profile['StatusCode'] !== '00') {
            return null;
        }

        $customer = new Customer();
        $customer->setValues($profile['Value']);

        //$this->session->set('AccessToken', $accessToken);
        //$this->session->set('UserProfile', $customer);
        $this->session->remove('fromDotNET');

        return $customer;
    }

    private function fromApi(Request $request)
    {
        $cookieName = getenv('COOKIE_NAME_DOT_NET_AUTOLOGIN', null);

        $cookies = $request->cookies;
        $accessToken = $cookies->get($cookieName);

        if (env('RRR_LIVE')) {
            $profile = $this->member->profile($accessToken);
        }

        if (!env('RRR_LIVE')) {
            $profile = $this->account->profile($accessToken);
        }

        if ($profile['StatusCode'] !== '00') {
            return null;
        }

        $customer = new Customer();
        $customer->setValues($profile['Value']);

        $this->session->remove('fromApi');
        $this->session->set('UserProfile', $customer);
        $this->session->set('UserProfileRaw', $profile['Value']);

        return $customer;
    }

    protected function setActionTokenCookie($accessToken)
    {
        $dotNetDomain = env('WILDCARD_DOMAIN_FOR_DOT_NET', null);

        $expiredCookie = Carbon::now()->addMinutes(30)->timestamp;

        setrawcookie(
            'action_token',
            $accessToken,
            $expiredCookie,
            '/',
            $dotNetDomain
        );
    }
}
